Merge remote-tracking branch 'origin/stable-2.0'
[bpt/guile.git] / maint.mk
1 # -*-Makefile-*-
2 # This Makefile fragment tries to be general-purpose enough to be
3 # used by many projects via the gnulib maintainer-makefile module.
4
5 ## Copyright (C) 2001-2012 Free Software Foundation, Inc.
6 ##
7 ## This program is free software: you can redistribute it and/or modify
8 ## it under the terms of the GNU General Public License as published by
9 ## the Free Software Foundation, either version 3 of the License, or
10 ## (at your option) any later version.
11 ##
12 ## This program is distributed in the hope that it will be useful,
13 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
14 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 ## GNU General Public License for more details.
16 ##
17 ## You should have received a copy of the GNU General Public License
18 ## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20 # This is reported not to work with make-3.79.1
21 # ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22 ME := maint.mk
23
24 # Diagnostic for continued use of deprecated variable.
25 # Remove in 2013
26 ifneq ($(build_aux),)
27 $(error "$(ME): \
28 set $$(_build-aux) relative to $$(srcdir) instead of $$(build_aux)")
29 endif
30
31 # Do not save the original name or timestamp in the .tar.gz file.
32 # Use --rsyncable if available.
33 gzip_rsyncable := \
34 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
35 && printf %s --rsyncable)
36 GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
37
38 GIT = git
39 VC = $(GIT)
40
41 VC_LIST = $(srcdir)/$(_build-aux)/vc-list-files -C $(srcdir)
42
43 # You can override this variable in cfg.mk to set your own regexp
44 # matching files to ignore.
45 VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
46
47 # This is to preprocess robustly the output of $(VC_LIST), so that even
48 # when $(srcdir) is a pathological name like "....", the leading sed command
49 # removes only the intended prefix.
50 _dot_escaped_srcdir = $(subst .,\.,$(srcdir))
51
52 # Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
53 # when $(srcdir) is not ".".
54 ifeq ($(srcdir),.)
55 _prepend_srcdir_prefix =
56 else
57 _prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
58 endif
59
60 # In order to be able to consistently filter "."-relative names,
61 # (i.e., with no $(srcdir) prefix), this definition is careful to
62 # remove any $(srcdir) prefix, and to restore what it removes.
63 _sc_excl = \
64 $(if $(exclude_file_name_regexp--$@),$(exclude_file_name_regexp--$@),^$$)
65 VC_LIST_EXCEPT = \
66 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
67 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
68 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
69 | grep -Ev -e '($(VC_LIST_ALWAYS_EXCLUDE_REGEX)|$(_sc_excl))' \
70 $(_prepend_srcdir_prefix)
71
72 ifeq ($(origin prev_version_file), undefined)
73 prev_version_file = $(srcdir)/.prev-version
74 endif
75
76 PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
77 VERSION_REGEXP = $(subst .,\.,$(VERSION))
78 PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
79
80 ifeq ($(VC),$(GIT))
81 this-vc-tag = v$(VERSION)
82 this-vc-tag-regexp = v$(VERSION_REGEXP)
83 else
84 tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
85 tag-this-version = $(subst .,_,$(VERSION))
86 this-vc-tag = $(tag-package)-$(tag-this-version)
87 this-vc-tag-regexp = $(this-vc-tag)
88 endif
89 my_distdir = $(PACKAGE)-$(VERSION)
90
91 # Old releases are stored here.
92 release_archive_dir ?= ../release
93
94 # Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
95 # Use alpha.gnu.org for alpha and beta releases.
96 # Use ftp.gnu.org for stable releases.
97 gnu_ftp_host-alpha = alpha.gnu.org
98 gnu_ftp_host-beta = alpha.gnu.org
99 gnu_ftp_host-stable = ftp.gnu.org
100 gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
101
102 ifeq ($(gnu_rel_host),ftp.gnu.org)
103 url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
104 else
105 url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
106 endif
107
108 # Override this in cfg.mk if you are using a different format in your
109 # NEWS file.
110 today = $(shell date +%Y-%m-%d)
111
112 # Select which lines of NEWS are searched for $(news-check-regexp).
113 # This is a sed line number spec. The default says that we search
114 # lines 1..10 of NEWS for $(news-check-regexp).
115 # If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
116 news-check-lines-spec ?= 1,10
117 news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
118
119 # Prevent programs like 'sort' from considering distinct strings to be equal.
120 # Doing it here saves us from having to set LC_ALL elsewhere in this file.
121 export LC_ALL = C
122
123 ## --------------- ##
124 ## Sanity checks. ##
125 ## --------------- ##
126
127 _cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
128
129 # Collect the names of rules starting with 'sc_'.
130 syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
131 $(srcdir)/$(ME) $(_cfg_mk)))
132 .PHONY: $(syntax-check-rules)
133
134 ifeq ($(shell $(VC_LIST) >/dev/null 2>&1; echo $$?),0)
135 local-checks-available += $(syntax-check-rules)
136 else
137 local-checks-available += no-vc-detected
138 no-vc-detected:
139 @echo "No version control files detected; skipping syntax check"
140 endif
141 .PHONY: $(local-checks-available)
142
143 # Arrange to print the name of each syntax-checking rule just before running it.
144 $(syntax-check-rules): %: %.m
145 sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
146 .PHONY: $(sc_m_rules_)
147 $(sc_m_rules_):
148 @echo $(patsubst sc_%.m, %, $@)
149 @date +%s.%N > .sc-start-$(basename $@)
150
151 # Compute and print the elapsed time for each syntax-check rule.
152 sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
153 .PHONY: $(sc_z_rules_)
154 $(sc_z_rules_): %.z: %
155 @end=$$(date +%s.%N); \
156 start=$$(cat .sc-start-$*); \
157 rm -f .sc-start-$*; \
158 awk -v s=$$start -v e=$$end \
159 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
160
161 # The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
162 # that computes and prints elapsed time.
163 local-check := \
164 $(patsubst sc_%, sc_%.z, \
165 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
166
167 syntax-check: $(local-check)
168
169 # _sc_search_regexp
170 #
171 # This macro searches for a given construct in the selected files and
172 # then takes some action.
173 #
174 # Parameters (shell variables):
175 #
176 # prohibit | require
177 #
178 # Regular expression (ERE) denoting either a forbidden construct
179 # or a required construct. Those arguments are exclusive.
180 #
181 # in_vc_files | in_files
182 #
183 # grep-E-style regexp denoting the files to check. If no files
184 # are specified the default are all the files that are under
185 # version control.
186 #
187 # containing | non_containing
188 #
189 # Select the files (non) containing strings matching this regexp.
190 # If both arguments are specified then CONTAINING takes
191 # precedence.
192 #
193 # with_grep_options
194 #
195 # Extra options for grep.
196 #
197 # ignore_case
198 #
199 # Ignore case.
200 #
201 # halt
202 #
203 # Message to display before to halting execution.
204 #
205 # Finally, you may exempt files based on an ERE matching file names.
206 # For example, to exempt from the sc_space_tab check all files with the
207 # .diff suffix, set this Make variable:
208 #
209 # exclude_file_name_regexp--sc_space_tab = \.diff$
210 #
211 # Note that while this functionality is mostly inherited via VC_LIST_EXCEPT,
212 # when filtering by name via in_files, we explicitly filter out matching
213 # names here as well.
214
215 # By default, _sc_search_regexp does not ignore case.
216 export ignore_case =
217 _ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
218
219 define _sc_say_and_exit
220 dummy=; : so we do not need a semicolon before each use; \
221 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
222 endef
223
224 define _sc_search_regexp
225 dummy=; : so we do not need a semicolon before each use; \
226 \
227 : Check arguments; \
228 test -n "$$prohibit" && test -n "$$require" \
229 && { msg='Cannot specify both prohibit and require' \
230 $(_sc_say_and_exit) } || :; \
231 test -z "$$prohibit" && test -z "$$require" \
232 && { msg='Should specify either prohibit or require' \
233 $(_sc_say_and_exit) } || :; \
234 test -n "$$in_vc_files" && test -n "$$in_files" \
235 && { msg='Cannot specify both in_vc_files and in_files' \
236 $(_sc_say_and_exit) } || :; \
237 test "x$$halt" != x \
238 || { msg='halt not defined' $(_sc_say_and_exit) }; \
239 \
240 : Filter by file name; \
241 if test -n "$$in_files"; then \
242 files=$$(find $(srcdir) | grep -E "$$in_files" \
243 | grep -Ev '$(exclude_file_name_regexp--$@)'); \
244 else \
245 files=$$($(VC_LIST_EXCEPT)); \
246 if test -n "$$in_vc_files"; then \
247 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
248 fi; \
249 fi; \
250 \
251 : Filter by content; \
252 test -n "$$files" && test -n "$$containing" \
253 && { files=$$(grep -l "$$containing" $$files); } || :; \
254 test -n "$$files" && test -n "$$non_containing" \
255 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
256 \
257 : Check for the construct; \
258 if test -n "$$files"; then \
259 if test -n "$$prohibit"; then \
260 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
261 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
262 else \
263 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
264 | grep . \
265 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
266 fi \
267 else :; \
268 fi || :;
269 endef
270
271 sc_avoid_if_before_free:
272 @$(srcdir)/$(_build-aux)/useless-if-before-free \
273 $(useless_free_options) \
274 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
275 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
276 exit 1; } || :
277
278 sc_cast_of_argument_to_free:
279 @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \
280 $(_sc_search_regexp)
281
282 sc_cast_of_x_alloc_return_value:
283 @prohibit='\*\) *x(m|c|re)alloc\>' \
284 halt='don'\''t cast x*alloc return value' \
285 $(_sc_search_regexp)
286
287 sc_cast_of_alloca_return_value:
288 @prohibit='\*\) *alloca\>' \
289 halt='don'\''t cast alloca return value' \
290 $(_sc_search_regexp)
291
292 sc_space_tab:
293 @prohibit='[ ] ' \
294 halt='found SPACE-TAB sequence; remove the SPACE' \
295 $(_sc_search_regexp)
296
297 # Don't use *scanf or the old ato* functions in "real" code.
298 # They provide no error checking mechanism.
299 # Instead, use strto* functions.
300 sc_prohibit_atoi_atof:
301 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
302 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
303 $(_sc_search_regexp)
304
305 # Use STREQ rather than comparing strcmp == 0, or != 0.
306 sc_prohibit_strcmp:
307 @grep -nE '! *str''cmp *\(|\<str''cmp *\(.+\) *[!=]=' \
308 $$($(VC_LIST_EXCEPT)) \
309 | grep -vE ':# *define STRN?EQ\(' && \
310 { echo '$(ME): replace str''cmp calls above with STREQ/STRNEQ' \
311 1>&2; exit 1; } || :
312
313 # Pass EXIT_*, not number, to usage, exit, and error (when exiting)
314 # Convert all uses automatically, via these two commands:
315 # git grep -l '\<exit *(1)' \
316 # | grep -vEf .x-sc_prohibit_magic_number_exit \
317 # | xargs --no-run-if-empty \
318 # perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
319 # git grep -l '\<exit *(0)' \
320 # | grep -vEf .x-sc_prohibit_magic_number_exit \
321 # | xargs --no-run-if-empty \
322 # perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
323 sc_prohibit_magic_number_exit:
324 @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
325 halt='use EXIT_* values rather than magic number' \
326 $(_sc_search_regexp)
327
328 # Using EXIT_SUCCESS as the first argument to error is misleading,
329 # since when that parameter is 0, error does not exit. Use '0' instead.
330 sc_error_exit_success:
331 @prohibit='error *\(EXIT_SUCCESS,' \
332 in_vc_files='\.[chly]$$' \
333 halt='found error (EXIT_SUCCESS' \
334 $(_sc_search_regexp)
335
336 # "FATAL:" should be fully upper-cased in error messages
337 # "WARNING:" should be fully upper-cased, or fully lower-cased
338 sc_error_message_warn_fatal:
339 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
340 | grep -E '"Warning|"Fatal|"fatal' && \
341 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
342 exit 1; } || :
343
344 # Error messages should not start with a capital letter
345 sc_error_message_uppercase:
346 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
347 | grep -E '"[A-Z]' \
348 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
349 { echo '$(ME): found capitalized error message' 1>&2; \
350 exit 1; } || :
351
352 # Error messages should not end with a period
353 sc_error_message_period:
354 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
355 | grep -E '[^."]\."' && \
356 { echo '$(ME): found error message ending in period' 1>&2; \
357 exit 1; } || :
358
359 sc_file_system:
360 @prohibit=file''system \
361 ignore_case=1 \
362 halt='found use of "file''system"; spell it "file system"' \
363 $(_sc_search_regexp)
364
365 # Don't use cpp tests of this symbol. All code assumes config.h is included.
366 sc_prohibit_have_config_h:
367 @prohibit='^# *if.*HAVE''_CONFIG_H' \
368 halt='found use of HAVE''_CONFIG_H; remove' \
369 $(_sc_search_regexp)
370
371 # Nearly all .c files must include <config.h>. However, we also permit this
372 # via inclusion of a package-specific header, if cfg.mk specified one.
373 # config_h_header must be suitable for grep -E.
374 config_h_header ?= <config\.h>
375 sc_require_config_h:
376 @require='^# *include $(config_h_header)' \
377 in_vc_files='\.c$$' \
378 halt='the above files do not include <config.h>' \
379 $(_sc_search_regexp)
380
381 # You must include <config.h> before including any other header file.
382 # This can possibly be via a package-specific header, if given by cfg.mk.
383 sc_require_config_h_first:
384 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
385 fail=0; \
386 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
387 grep '^# *include\>' $$i | sed 1q \
388 | grep -E '^# *include $(config_h_header)' > /dev/null \
389 || { echo $$i; fail=1; }; \
390 done; \
391 test $$fail = 1 && \
392 { echo '$(ME): the above files include some other header' \
393 'before <config.h>' 1>&2; exit 1; } || :; \
394 else :; \
395 fi
396
397 sc_prohibit_HAVE_MBRTOWC:
398 @prohibit='\bHAVE_MBRTOWC\b' \
399 halt="do not use $$prohibit; it is always defined" \
400 $(_sc_search_regexp)
401
402 # To use this "command" macro, you must first define two shell variables:
403 # h: the header name, with no enclosing <> or ""
404 # re: a regular expression that matches IFF something provided by $h is used.
405 define _sc_header_without_use
406 dummy=; : so we do not need a semicolon before each use; \
407 h_esc=`echo '[<"]'"$$h"'[">]'|sed 's/\./\\\\./g'`; \
408 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
409 files=$$(grep -l '^# *include '"$$h_esc" \
410 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
411 grep -LE "$$re" $$files | grep . && \
412 { echo "$(ME): the above files include $$h but don't use it" \
413 1>&2; exit 1; } || :; \
414 else :; \
415 fi
416 endef
417
418 # Prohibit the inclusion of assert.h without an actual use of assert.
419 sc_prohibit_assert_without_use:
420 @h='assert.h' re='\<assert *\(' $(_sc_header_without_use)
421
422 # Prohibit the inclusion of close-stream.h without an actual use.
423 sc_prohibit_close_stream_without_use:
424 @h='close-stream.h' re='\<close_stream *\(' $(_sc_header_without_use)
425
426 # Prohibit the inclusion of getopt.h without an actual use.
427 sc_prohibit_getopt_without_use:
428 @h='getopt.h' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
429
430 # Don't include quotearg.h unless you use one of its functions.
431 sc_prohibit_quotearg_without_use:
432 @h='quotearg.h' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
433
434 # Don't include quote.h unless you use one of its functions.
435 sc_prohibit_quote_without_use:
436 @h='quote.h' re='\<quote(_n)? *\(' $(_sc_header_without_use)
437
438 # Don't include this header unless you use one of its functions.
439 sc_prohibit_long_options_without_use:
440 @h='long-options.h' re='\<parse_long_options *\(' \
441 $(_sc_header_without_use)
442
443 # Don't include this header unless you use one of its functions.
444 sc_prohibit_inttostr_without_use:
445 @h='inttostr.h' re='\<(off|[iu]max|uint)tostr *\(' \
446 $(_sc_header_without_use)
447
448 # Don't include this header unless you use one of its functions.
449 sc_prohibit_ignore_value_without_use:
450 @h='ignore-value.h' re='\<ignore_(value|ptr) *\(' \
451 $(_sc_header_without_use)
452
453 # Don't include this header unless you use one of its functions.
454 sc_prohibit_error_without_use:
455 @h='error.h' \
456 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
457 $(_sc_header_without_use)
458
459 # Don't include xalloc.h unless you use one of its functions.
460 # Consider these symbols:
461 # perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
462 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
463 # Divide into two sets on case, and filter each through this:
464 # | sort | perl -MRegexp::Assemble -le \
465 # 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
466 # Note this was produced by the above:
467 # _xa1 = \
468 #x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
469 # But we can do better, in at least two ways:
470 # 1) take advantage of two "dup"-suffixed strings:
471 # x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
472 # 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
473 # "char|[cmz]"
474 # x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
475 _xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
476 _xa2 = X([CZ]|N?M)ALLOC
477 sc_prohibit_xalloc_without_use:
478 @h='xalloc.h' \
479 re='\<($(_xa1)|$(_xa2)) *\('\
480 $(_sc_header_without_use)
481
482 # Extract function names:
483 # perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
484 _hash_re = \
485 clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
486 _hash_fn = \<($(_hash_re)) *\(
487 _hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
488 sc_prohibit_hash_without_use:
489 @h='hash.h' \
490 re='$(_hash_fn)|$(_hash_struct)'\
491 $(_sc_header_without_use)
492
493 sc_prohibit_cloexec_without_use:
494 @h='cloexec.h' re='\<(set_cloexec_flag|dup_cloexec) *\(' \
495 $(_sc_header_without_use)
496
497 sc_prohibit_posixver_without_use:
498 @h='posixver.h' re='\<posix2_version *\(' $(_sc_header_without_use)
499
500 sc_prohibit_same_without_use:
501 @h='same.h' re='\<same_name *\(' $(_sc_header_without_use)
502
503 sc_prohibit_hash_pjw_without_use:
504 @h='hash-pjw.h' \
505 re='\<hash_pjw *\(' \
506 $(_sc_header_without_use)
507
508 sc_prohibit_safe_read_without_use:
509 @h='safe-read.h' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
510 $(_sc_header_without_use)
511
512 sc_prohibit_argmatch_without_use:
513 @h='argmatch.h' \
514 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<(invalid_arg|argmatch(_exit_fn|_(in)?valid)?) *\()' \
515 $(_sc_header_without_use)
516
517 sc_prohibit_canonicalize_without_use:
518 @h='canonicalize.h' \
519 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
520 $(_sc_header_without_use)
521
522 sc_prohibit_root_dev_ino_without_use:
523 @h='root-dev-ino.h' \
524 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
525 $(_sc_header_without_use)
526
527 sc_prohibit_openat_without_use:
528 @h='openat.h' \
529 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
530 $(_sc_header_without_use)
531
532 # Prohibit the inclusion of c-ctype.h without an actual use.
533 ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
534 |isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
535 sc_prohibit_c_ctype_without_use:
536 @h='c-ctype.h' re='\<c_($(ctype_re)) *\(' \
537 $(_sc_header_without_use)
538
539 _empty =
540 _sp = $(_empty) $(_empty)
541 # The following list was generated by running:
542 # man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
543 # | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
544 _sig_functions = \
545 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
546 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
547 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
548 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
549 _sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
550 # The following were extracted from "man signal.h" manually.
551 _sig_types_and_consts = \
552 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
553 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
554 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
555 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
556 sigstack sigval stack_t ucontext_t
557 # generated via this:
558 # perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
559 _sig_names = \
560 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
561 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
562 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
563 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
564 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
565 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
566 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
567 SIGXCPU SIGXFSZ
568 _sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
569
570 # Prohibit the inclusion of signal.h without an actual use.
571 sc_prohibit_signal_without_use:
572 @h='signal.h' \
573 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
574 $(_sc_header_without_use)
575
576 # Don't include stdio--.h unless you use one of its functions.
577 sc_prohibit_stdio--_without_use:
578 @h='stdio--.h' re='\<((f(re)?|p)open|tmpfile) *\(' \
579 $(_sc_header_without_use)
580
581 # Don't include stdio-safer.h unless you use one of its functions.
582 sc_prohibit_stdio-safer_without_use:
583 @h='stdio-safer.h' re='\<((f(re)?|p)open|tmpfile)_safer *\(' \
584 $(_sc_header_without_use)
585
586 # Prohibit the inclusion of strings.h without a sensible use.
587 # Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
588 sc_prohibit_strings_without_use:
589 @h='strings.h' \
590 re='\<(strn?casecmp|ffs(ll)?)\>' \
591 $(_sc_header_without_use)
592
593 # Get the list of symbol names with this:
594 # perl -lne '/^# *define ([A-Z]\w+)\(/ and print $1' lib/intprops.h|fmt
595 _intprops_names = \
596 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
597 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
598 INT_BITS_STRLEN_BOUND INT_STRLEN_BOUND INT_BUFSIZE_BOUND \
599 INT_ADD_RANGE_OVERFLOW INT_SUBTRACT_RANGE_OVERFLOW \
600 INT_NEGATE_RANGE_OVERFLOW INT_MULTIPLY_RANGE_OVERFLOW \
601 INT_DIVIDE_RANGE_OVERFLOW INT_REMAINDER_RANGE_OVERFLOW \
602 INT_LEFT_SHIFT_RANGE_OVERFLOW INT_ADD_OVERFLOW INT_SUBTRACT_OVERFLOW \
603 INT_NEGATE_OVERFLOW INT_MULTIPLY_OVERFLOW INT_DIVIDE_OVERFLOW \
604 INT_REMAINDER_OVERFLOW INT_LEFT_SHIFT_OVERFLOW
605 _intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
606 # Prohibit the inclusion of intprops.h without an actual use.
607 sc_prohibit_intprops_without_use:
608 @h='intprops.h' \
609 re='\<($(_intprops_syms_re)) *\(' \
610 $(_sc_header_without_use)
611
612 _stddef_syms_re = NULL|offsetof|ptrdiff_t|size_t|wchar_t
613 # Prohibit the inclusion of stddef.h without an actual use.
614 sc_prohibit_stddef_without_use:
615 @h='stddef.h' \
616 re='\<($(_stddef_syms_re))\>' \
617 $(_sc_header_without_use)
618
619 _de1 = dirfd|(close|(fd)?open|read|rewind|seek|tell)dir(64)?(_r)?
620 _de2 = (versionsort|struct dirent|getdirentries|alphasort|scandir(at)?)(64)?
621 _de3 = MAXNAMLEN|DIR|ino_t|d_ino|d_fileno|d_namlen
622 _dirent_syms_re = $(_de1)|$(_de2)|$(_de3)
623 # Prohibit the inclusion of dirent.h without an actual use.
624 sc_prohibit_dirent_without_use:
625 @h='dirent.h' \
626 re='\<($(_dirent_syms_re))\>' \
627 $(_sc_header_without_use)
628
629 # Prohibit the inclusion of verify.h without an actual use.
630 sc_prohibit_verify_without_use:
631 @h='verify.h' \
632 re='\<(verify(true|expr)?|static_assert) *\(' \
633 $(_sc_header_without_use)
634
635 # Don't include xfreopen.h unless you use one of its functions.
636 sc_prohibit_xfreopen_without_use:
637 @h='xfreopen.h' re='\<xfreopen *\(' $(_sc_header_without_use)
638
639 sc_obsolete_symbols:
640 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
641 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
642 $(_sc_search_regexp)
643
644 # FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
645
646 # Each nonempty ChangeLog line must start with a year number, or a TAB.
647 sc_changelog:
648 @prohibit='^[^12 ]' \
649 in_vc_files='^ChangeLog$$' \
650 halt='found unexpected prefix in a ChangeLog' \
651 $(_sc_search_regexp)
652
653 # Ensure that each .c file containing a "main" function also
654 # calls set_program_name.
655 sc_program_name:
656 @require='set_program_name *\(m?argv\[0\]\);' \
657 in_vc_files='\.c$$' \
658 containing='\<main *(' \
659 halt='the above files do not call set_program_name' \
660 $(_sc_search_regexp)
661
662 # Ensure that each .c file containing a "main" function also
663 # calls bindtextdomain.
664 sc_bindtextdomain:
665 @require='bindtextdomain *\(' \
666 in_vc_files='\.c$$' \
667 containing='\<main *(' \
668 halt='the above files do not call bindtextdomain' \
669 $(_sc_search_regexp)
670
671 # Require that the final line of each test-lib.sh-using test be this one:
672 # Exit $fail
673 # Note: this test requires GNU grep's --label= option.
674 Exit_witness_file ?= tests/test-lib.sh
675 Exit_base := $(notdir $(Exit_witness_file))
676 sc_require_test_exit_idiom:
677 @if test -f $(srcdir)/$(Exit_witness_file); then \
678 die=0; \
679 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
680 $$($(VC_LIST) tests)); do \
681 tail -n1 $$i | grep '^Exit .' > /dev/null \
682 && : || { die=1; echo $$i; } \
683 done; \
684 test $$die = 1 && \
685 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
686 echo 1>&2 'Exit something'; \
687 exit 1; } || :; \
688 fi
689
690 sc_trailing_blank:
691 @prohibit='[ ]$$' \
692 halt='found trailing blank(s)' \
693 $(_sc_search_regexp)
694
695 # Match lines like the following, but where there is only one space
696 # between the options and the description:
697 # -D, --all-repeated[=delimit-method] print all duplicate lines\n
698 longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
699 sc_two_space_separator_in_usage:
700 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
701 halt='help2man requires at least two spaces between an option and its description'\
702 $(_sc_search_regexp)
703
704 # A regexp matching function names like "error" that may be used
705 # to emit translatable messages.
706 _gl_translatable_diag_func_re ?= error
707
708 # Look for diagnostics that aren't marked for translation.
709 # This won't find any for which error's format string is on a separate line.
710 sc_unmarked_diagnostics:
711 @grep -nE \
712 '\<$(_gl_translatable_diag_func_re) *\([^"]*"[^"]*[a-z]{3}' \
713 $$($(VC_LIST_EXCEPT)) \
714 | grep -Ev '(_|ngettext ?)\(' && \
715 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
716 exit 1; } || :
717
718 # Avoid useless parentheses like those in this example:
719 # #if defined (SYMBOL) || defined (SYM2)
720 sc_useless_cpp_parens:
721 @prohibit='^# *if .*defined *\(' \
722 halt='found useless parentheses in cpp directive' \
723 $(_sc_search_regexp)
724
725 # List headers for which HAVE_HEADER_H is always true, assuming you are
726 # using the appropriate gnulib module. CAUTION: for each "unnecessary"
727 # #if HAVE_HEADER_H that you remove, be sure that your project explicitly
728 # requires the gnulib module that guarantees the usability of that header.
729 gl_assured_headers_ = \
730 cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
731
732 # Convert the list of names to upper case, and replace each space with "|".
733 az_ = abcdefghijklmnopqrstuvwxyz
734 AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
735 gl_header_upper_case_or_ = \
736 $$($(gl_assured_headers_) \
737 | tr $(az_)/.- $(AZ_)___ \
738 | tr -s ' ' '|' \
739 )
740 sc_prohibit_always_true_header_tests:
741 @or=$(gl_header_upper_case_or_); \
742 re="HAVE_($$or)_H"; \
743 prohibit='\<'"$$re"'\>' \
744 halt=$$(printf '%s\n' \
745 'do not test the above HAVE_<header>_H symbol(s);' \
746 ' with the corresponding gnulib module, they are always true') \
747 $(_sc_search_regexp)
748
749 # ==================================================================
750 gl_other_headers_ ?= \
751 intprops.h \
752 openat.h \
753 stat-macros.h
754
755 # Perl -lne code to extract "significant" cpp-defined symbols from a
756 # gnulib header file, eliminating a few common false-positives.
757 # The exempted names below are defined only conditionally in gnulib,
758 # and hence sometimes must/may be defined in application code.
759 gl_extract_significant_defines_ = \
760 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
761 && $$2 !~ /(?:rpl_|_used_without_)/\
762 && $$1 !~ /^(?:NSIG|ENODATA)$$/\
763 && $$1 !~ /^(?:SA_RESETHAND|SA_RESTART)$$/\
764 and print $$1
765
766 # Create a list of regular expressions matching the names
767 # of macros that are guaranteed to be defined by parts of gnulib.
768 define def_sym_regex
769 gen_h=$(gl_generated_headers_); \
770 (cd $(gnulib_dir)/lib; \
771 for f in *.in.h $(gl_other_headers_); do \
772 test -f $$f \
773 && perl -lne '$(gl_extract_significant_defines_)' $$f; \
774 done; \
775 ) | sort -u \
776 | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
777 endef
778
779 # Don't define macros that we already get from gnulib header files.
780 sc_prohibit_always-defined_macros:
781 @if test -d $(gnulib_dir); then \
782 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
783 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
784 esac; \
785 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
786 && { echo '$(ME): define the above via some gnulib .h file' \
787 1>&2; exit 1; } || :; \
788 fi
789 # ==================================================================
790
791 # Prohibit checked in backup files.
792 sc_prohibit_backup_files:
793 @$(VC_LIST) | grep '~$$' && \
794 { echo '$(ME): found version controlled backup file' 1>&2; \
795 exit 1; } || :
796
797 # Require the latest GPL.
798 sc_GPL_version:
799 @prohibit='either ''version [^3]' \
800 halt='GPL vN, N!=3' \
801 $(_sc_search_regexp)
802
803 # Require the latest GFDL. Two regexp, since some .texi files end up
804 # line wrapping between 'Free Documentation License,' and 'Version'.
805 _GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
806 sc_GFDL_version:
807 @prohibit='$(_GFDL_regexp)' \
808 halt='GFDL vN, N!=3' \
809 $(_sc_search_regexp)
810
811 # Don't use Texinfo's @acronym{}.
812 # http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
813 texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
814 sc_texinfo_acronym:
815 @prohibit='@acronym\{' \
816 in_vc_files='$(texinfo_suffix_re_)' \
817 halt='found use of Texinfo @acronym{}' \
818 $(_sc_search_regexp)
819
820 cvs_keywords = \
821 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
822
823 sc_prohibit_cvs_keyword:
824 @prohibit='\$$($(cvs_keywords))\$$' \
825 halt='do not use CVS keyword expansion' \
826 $(_sc_search_regexp)
827
828 # This Perl code is slightly obfuscated. Not only is each "$" doubled
829 # because it's in a Makefile, but the $$c's are comments; we cannot
830 # use "#" due to the way the script ends up concatenated onto one line.
831 # It would be much more concise, and would produce better output (including
832 # counts) if written as:
833 # perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
834 # but that would be far less efficient, reading the entire contents
835 # of each file, rather than just the last two bytes of each.
836 # In addition, while the code below detects both blank lines and a missing
837 # newline at EOF, the above detects only the former.
838 #
839 # This is a perl script that is expected to be the single-quoted argument
840 # to a command-line "-le". The remaining arguments are file names.
841 # Print the name of each file that does not end in exactly one newline byte.
842 # I.e., warn if there are blank lines (2 or more newlines), or if the
843 # last byte is not a newline. However, currently we don't complain
844 # about any file that contains exactly one byte.
845 # Exit nonzero if at least one such file is found, otherwise, exit 0.
846 # Warn about, but otherwise ignore open failure. Ignore seek/read failure.
847 #
848 # Use this if you want to remove trailing empty lines from selected files:
849 # perl -pi -0777 -e 's/\n\n+$/\n/' files...
850 #
851 require_exactly_one_NL_at_EOF_ = \
852 foreach my $$f (@ARGV) \
853 { \
854 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
855 my $$p = sysseek (F, -2, 2); \
856 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
857 my $$last_two_bytes; \
858 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
859 close F; \
860 $$c = "ignore read failure"; \
861 $$p && ($$last_two_bytes eq "\n\n" \
862 || substr ($$last_two_bytes,1) ne "\n") \
863 and (print $$f), $$fail=1; \
864 } \
865 END { exit defined $$fail }
866 sc_prohibit_empty_lines_at_EOF:
867 @perl -le '$(require_exactly_one_NL_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
868 || { echo '$(ME): empty line(s) or no newline at EOF' \
869 1>&2; exit 1; } || :
870
871 # Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
872 # This is a bit of a kludge, since it prevents use of the string
873 # even in comments, but for now it does the job with no false positives.
874 sc_prohibit_stat_st_blocks:
875 @prohibit='[.>]st_blocks' \
876 halt='do not use st_blocks; use ST_NBLOCKS' \
877 $(_sc_search_regexp)
878
879 # Make sure we don't define any S_IS* macros in src/*.c files.
880 # They're already defined via gnulib's sys/stat.h replacement.
881 sc_prohibit_S_IS_definition:
882 @prohibit='^ *# *define *S_IS' \
883 halt='do not define S_IS* macros; include <sys/stat.h>' \
884 $(_sc_search_regexp)
885
886 # Perl block to convert a match to FILE_NAME:LINENO:TEST,
887 # that is shared by two definitions below.
888 perl_filename_lineno_text_ = \
889 -e ' {' \
890 -e ' $$n = ($$` =~ tr/\n/\n/ + 1);' \
891 -e ' ($$v = $$&) =~ s/\n/\\n/g;' \
892 -e ' print "$$ARGV:$$n:$$v\n";' \
893 -e ' }'
894
895 prohibit_doubled_word_RE_ ?= \
896 /\b(then?|[iao]n|i[fst]|but|f?or|at|and|[dt]o)\s+\1\b/gims
897 prohibit_doubled_word_ = \
898 -e 'while ($(prohibit_doubled_word_RE_))' \
899 $(perl_filename_lineno_text_)
900
901 # Define this to a regular expression that matches
902 # any filename:dd:match lines you want to ignore.
903 # The default is to ignore no matches.
904 ignore_doubled_word_match_RE_ ?= ^$$
905
906 sc_prohibit_doubled_word:
907 @perl -n -0777 $(prohibit_doubled_word_) $$($(VC_LIST_EXCEPT)) \
908 | grep -vE '$(ignore_doubled_word_match_RE_)' \
909 | grep . && { echo '$(ME): doubled words' 1>&2; exit 1; } || :
910
911 # A regular expression matching undesirable combinations of words like
912 # "can not"; this matches them even when the two words appear on different
913 # lines, but not when there is an intervening delimiter like "#" or "*".
914 prohibit_undesirable_word_seq_RE_ ?= \
915 /\bcan\s+not\b/gims
916 prohibit_undesirable_word_seq_ = \
917 -e 'while ($(prohibit_undesirable_word_seq_RE_))' \
918 $(perl_filename_lineno_text_)
919 # Define this to a regular expression that matches
920 # any filename:dd:match lines you want to ignore.
921 # The default is to ignore no matches.
922 ignore_undesirable_word_sequence_RE_ ?= ^$$
923
924 sc_prohibit_undesirable_word_seq:
925 @perl -n -0777 $(prohibit_undesirable_word_seq_) \
926 $$($(VC_LIST_EXCEPT)) \
927 | grep -vE '$(ignore_undesirable_word_sequence_RE_)' | grep . \
928 && { echo '$(ME): undesirable word sequence' >&2; exit 1; } || :
929
930 _ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
931 _ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
932 # Using test's -a and -o operators is not portable.
933 # We prefer test over [, since the latter is spelled [[ in configure.ac.
934 sc_prohibit_test_minus_ao:
935 @prohibit='(\<test| \[+) .+ -[ao] ' \
936 halt='$(_ptm1); $(_ptm2)' \
937 $(_sc_search_regexp)
938
939 # Avoid a test bashism.
940 sc_prohibit_test_double_equal:
941 @prohibit='(\<test| \[+) .+ == ' \
942 containing='#! */bin/[a-z]*sh' \
943 halt='use "test x = x", not "test x =''= x"' \
944 $(_sc_search_regexp)
945
946 # Each program that uses proper_name_utf8 must link with one of the
947 # ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
948 # The perl -0777 invocation below extracts the possibly-multi-line
949 # definition of LDADD from the appropriate Makefile.am and exits 0
950 # when it contains "ICONV".
951 sc_proper_name_utf8_requires_ICONV:
952 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
953 if test "x$$progs" != x; then \
954 fail=0; \
955 for p in $$progs; do \
956 dir=$$(dirname "$$p"); \
957 perl -0777 \
958 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
959 $$dir/Makefile.am && continue; \
960 base=$$(basename "$$p" .c); \
961 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
962 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
963 done; \
964 test $$fail = 1 && \
965 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
966 exit 1; } || :; \
967 fi
968
969 # Warn about "c0nst struct Foo const foo[]",
970 # but not about "char const *const foo" or "#define const const".
971 sc_redundant_const:
972 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
973 halt='redundant "const" in declarations' \
974 $(_sc_search_regexp)
975
976 sc_const_long_option:
977 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
978 | grep -Ev 'const struct option|struct option const' && { \
979 echo 1>&2 '$(ME): add "const" to the above declarations'; \
980 exit 1; } || :
981
982 NEWS_hash = \
983 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
984 $(srcdir)/NEWS \
985 | perl -0777 -pe \
986 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
987 | md5sum - \
988 | sed 's/ .*//')
989
990 # Ensure that we don't accidentally insert an entry into an old NEWS block.
991 sc_immutable_NEWS:
992 @if test -f $(srcdir)/NEWS; then \
993 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
994 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
995 fi
996
997 # Update the hash stored above. Do this after each release and
998 # for any corrections to old entries.
999 update-NEWS-hash: NEWS
1000 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
1001 $(srcdir)/cfg.mk
1002
1003 # Ensure that we use only the standard $(VAR) notation,
1004 # not @...@ in Makefile.am, now that we can rely on automake
1005 # to emit a definition for each substituted variable.
1006 # However, there is still one case in which @VAR@ use is not just
1007 # legitimate, but actually required: when augmenting an automake-defined
1008 # variable with a prefix. For example, gettext uses this:
1009 # MAKEINFO = env LANG= LC_MESSAGES= LC_ALL= LANGUAGE= @MAKEINFO@
1010 # otherwise, makeinfo would put German or French (current locale)
1011 # navigation hints in the otherwise-English documentation.
1012 #
1013 # Allow the package to add exceptions via a hook in cfg.mk;
1014 # for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
1015 # setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
1016 _makefile_at_at_check_exceptions ?=
1017 sc_makefile_at_at_check:
1018 @perl -ne '/\@[A-Z_0-9]+\@/' \
1019 -e ' && !/([A-Z_0-9]+)\s+=.*\@\1\@$$/' \
1020 -e ''$(_makefile_at_at_check_exceptions) \
1021 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
1022 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)(Makefile\.am|[^/]+\.mk)$$') \
1023 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
1024
1025 news-check: NEWS
1026 if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS \
1027 | grep -E $(news-check-regexp) >/dev/null; then \
1028 :; \
1029 else \
1030 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
1031 exit 1; \
1032 fi
1033
1034 sc_makefile_TAB_only_indentation:
1035 @prohibit='^ [ ]{8}' \
1036 in_vc_files='akefile|\.mk$$' \
1037 halt='found TAB-8-space indentation' \
1038 $(_sc_search_regexp)
1039
1040 sc_m4_quote_check:
1041 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
1042 in_vc_files='(^configure\.ac|\.m4)$$' \
1043 halt='quote the first arg to AC_DEF*' \
1044 $(_sc_search_regexp)
1045
1046 fix_po_file_diag = \
1047 'you have changed the set of files with translatable diagnostics;\n\
1048 apply the above patch\n'
1049
1050 # Verify that all source files using _() are listed in po/POTFILES.in.
1051 po_file ?= $(srcdir)/po/POTFILES.in
1052 generated_files ?= $(srcdir)/lib/*.[ch]
1053 sc_po_check:
1054 @if test -f $(po_file); then \
1055 grep -E -v '^(#|$$)' $(po_file) \
1056 | grep -v '^src/false\.c$$' | sort > $@-1; \
1057 files=; \
1058 for file in $$($(VC_LIST_EXCEPT)) $(generated_files); do \
1059 test -r $$file || continue; \
1060 case $$file in \
1061 *.m4|*.mk) continue ;; \
1062 *.?|*.??) ;; \
1063 *) continue;; \
1064 esac; \
1065 case $$file in \
1066 *.[ch]) \
1067 base=`expr " $$file" : ' \(.*\)\..'`; \
1068 { test -f $$base.l || test -f $$base.y; } && continue;; \
1069 esac; \
1070 files="$$files $$file"; \
1071 done; \
1072 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
1073 | sed 's|^$(_dot_escaped_srcdir)/||' | sort -u > $@-2; \
1074 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
1075 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
1076 rm -f $@-1 $@-2; \
1077 fi
1078
1079 # Sometimes it is useful to change the PATH environment variable
1080 # in Makefiles. When doing so, it's better not to use the Unix-centric
1081 # path separator of ':', but rather the automake-provided '$(PATH_SEPARATOR)'.
1082 msg = '$(ME): Do not use '\'':'\'' above; use $$(PATH_SEPARATOR) instead'
1083 sc_makefile_path_separator_check:
1084 @prohibit='PATH[=].*:' \
1085 in_vc_files='akefile|\.mk$$' \
1086 halt=$(msg) \
1087 $(_sc_search_regexp)
1088
1089 # Check that 'make alpha' will not fail at the end of the process,
1090 # i.e., when pkg-M.N.tar.xz already exists (either in "." or in ../release)
1091 # and is read-only.
1092 writable-files:
1093 if test -d $(release_archive_dir); then \
1094 for file in $(DIST_ARCHIVES); do \
1095 for p in ./ $(release_archive_dir)/; do \
1096 test -e $$p$$file || continue; \
1097 test -w $$p$$file \
1098 || { echo ERROR: $$p$$file is not writable; fail=1; }; \
1099 done; \
1100 done; \
1101 test "$$fail" && exit 1 || : ; \
1102 else :; \
1103 fi
1104
1105 v_etc_file = $(gnulib_dir)/lib/version-etc.c
1106 sample-test = tests/sample-test
1107 texi = doc/$(PACKAGE).texi
1108 # Make sure that the copyright date in $(v_etc_file) is up to date.
1109 # Do the same for the $(sample-test) and the main doc/.texi file.
1110 sc_copyright_check:
1111 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
1112 in_files=$(v_etc_file) \
1113 halt='out of date copyright in $(v_etc_file); update it' \
1114 $(_sc_search_regexp)
1115 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
1116 in_vc_files=$(sample-test) \
1117 halt='out of date copyright in $(sample-test); update it' \
1118 $(_sc_search_regexp)
1119 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
1120 in_vc_files=$(texi) \
1121 halt='out of date copyright in $(texi); update it' \
1122 $(_sc_search_regexp)
1123
1124 # If tests/help-version exists and seems to be new enough, assume that its
1125 # use of init.sh and path_prepend_ is correct, and ensure that every other
1126 # use of init.sh is identical.
1127 # This is useful because help-version cross-checks prog --version
1128 # with $(VERSION), which verifies that its path_prepend_ invocation
1129 # sets PATH correctly. This is an inexpensive way to ensure that
1130 # the other init.sh-using tests also get it right.
1131 _hv_file ?= $(srcdir)/tests/help-version
1132 _hv_regex_weak ?= ^ *\. .*/init\.sh"
1133 # Fix syntax-highlighters "
1134 _hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1135 sc_cross_check_PATH_usage_in_tests:
1136 @if test -f $(_hv_file); then \
1137 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1138 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1139 exit 0; }; \
1140 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1141 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1142 exit 1; }; \
1143 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
1144 grep -LFx "$$good" \
1145 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
1146 | grep . && \
1147 { echo "$(ME): the above files use path_prepend_ inconsistently" \
1148 1>&2; exit 1; } || :; \
1149 fi
1150
1151 # BRE regex of file contents to identify a test script.
1152 _test_script_regex ?= \<init\.sh\>
1153
1154 # In tests, use "compare expected actual", not the reverse.
1155 sc_prohibit_reversed_compare_failure:
1156 @prohibit='\<compare [^ ]+ ([^ ]*exp|/dev/null)' \
1157 containing='$(_test_script_regex)' \
1158 halt='reversed compare arguments' \
1159 $(_sc_search_regexp)
1160
1161 # #if HAVE_... will evaluate to false for any non numeric string.
1162 # That would be flagged by using -Wundef, however gnulib currently
1163 # tests many undefined macros, and so we can't enable that option.
1164 # So at least preclude common boolean strings as macro values.
1165 sc_Wundef_boolean:
1166 @prohibit='^#define.*(yes|no|true|false)$$' \
1167 in_files='$(CONFIG_INCLUDE)' \
1168 halt='Use 0 or 1 for macro values' \
1169 $(_sc_search_regexp)
1170
1171 # Even if you use pathmax.h to guarantee that PATH_MAX is defined, it might
1172 # not be constant, or might overflow a stack. In general, use PATH_MAX as
1173 # a limit, not an array or alloca size.
1174 sc_prohibit_path_max_allocation:
1175 @prohibit='(\balloca *\([^)]*|\[[^]]*)PATH_MAX' \
1176 halt='Avoid stack allocations of size PATH_MAX' \
1177 $(_sc_search_regexp)
1178
1179 sc_vulnerable_makefile_CVE-2009-4029:
1180 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1181 in_files=$$(find $(srcdir) -name Makefile.in) \
1182 halt=$$(printf '%s\n' \
1183 'the above files are vulnerable; beware of running' \
1184 ' "make dist*" rules, and upgrade to fixed automake' \
1185 ' see http://bugzilla.redhat.com/542609 for details') \
1186 $(_sc_search_regexp)
1187
1188 vc-diff-check:
1189 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1190 if test -s vc-diffs; then \
1191 cat vc-diffs; \
1192 echo "Some files are locally modified:" 1>&2; \
1193 exit 1; \
1194 else \
1195 rm vc-diffs; \
1196 fi
1197
1198 rel-files = $(DIST_ARCHIVES)
1199
1200 gnulib_dir ?= $(srcdir)/gnulib
1201 gnulib-version = $$(cd $(gnulib_dir) && git describe)
1202 bootstrap-tools ?= autoconf,automake,gnulib
1203
1204 # If it's not already specified, derive the GPG key ID from
1205 # the signed tag we've just applied to mark this release.
1206 gpg_key_ID ?= \
1207 $$(git cat-file tag v$(VERSION) \
1208 | gpgv --status-fd 1 --keyring /dev/null - - 2>/dev/null \
1209 | sed -n '/^\[GNUPG:\] ERRSIG /{s///;s/ .*//p;q}')
1210
1211 translation_project_ ?= coordinator@translationproject.org
1212
1213 # Make info-gnu the default only for a stable release.
1214 ifeq ($(RELEASE_TYPE),stable)
1215 announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1216 announcement_mail_headers_ ?= \
1217 To: info-gnu@gnu.org \
1218 Cc: $(announcement_Cc_) \
1219 Mail-Followup-To: $(PACKAGE_BUGREPORT)
1220 else
1221 announcement_Cc_ ?= $(translation_project_)
1222 announcement_mail_headers_ ?= \
1223 To: $(PACKAGE_BUGREPORT) \
1224 Cc: $(announcement_Cc_)
1225 endif
1226
1227 announcement: NEWS ChangeLog $(rel-files)
1228 @$(srcdir)/$(_build-aux)/announce-gen \
1229 --mail-headers='$(announcement_mail_headers_)' \
1230 --release-type=$(RELEASE_TYPE) \
1231 --package=$(PACKAGE) \
1232 --prev=$(PREV_VERSION) \
1233 --curr=$(VERSION) \
1234 --gpg-key-id=$(gpg_key_ID) \
1235 --news=$(srcdir)/NEWS \
1236 --bootstrap-tools=$(bootstrap-tools) \
1237 --gnulib-version=$(gnulib-version) \
1238 --no-print-checksums \
1239 $(addprefix --url-dir=, $(url_dir_list))
1240
1241 ## ---------------- ##
1242 ## Updating files. ##
1243 ## ---------------- ##
1244
1245 ftp-gnu = ftp://ftp.gnu.org/gnu
1246 www-gnu = http://www.gnu.org
1247
1248 upload_dest_dir_ ?= $(PACKAGE)
1249 emit_upload_commands:
1250 @echo =====================================
1251 @echo =====================================
1252 @echo "$(srcdir)/$(_build-aux)/gnupload $(GNUPLOADFLAGS) \\"
1253 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
1254 @echo " $(rel-files)"
1255 @echo '# send the ~/announce-$(my_distdir) e-mail'
1256 @echo =====================================
1257 @echo =====================================
1258
1259 define emit-commit-log
1260 printf '%s\n' 'maint: post-release administrivia' '' \
1261 '* NEWS: Add header line for next release.' \
1262 '* .prev-version: Record previous version.' \
1263 '* cfg.mk (old_NEWS_hash): Auto-update.'
1264 endef
1265
1266 .PHONY: no-submodule-changes
1267 no-submodule-changes:
1268 if test -d $(srcdir)/.git; then \
1269 diff=$$(cd $(srcdir) && git submodule -q foreach \
1270 git diff-index --name-only HEAD) \
1271 || exit 1; \
1272 case $$diff in '') ;; \
1273 *) echo '$(ME): submodule files are locally modified:'; \
1274 echo "$$diff"; exit 1;; esac; \
1275 else \
1276 : ; \
1277 fi
1278
1279 submodule-checks ?= no-submodule-changes public-submodule-commit
1280
1281 # Ensure that each sub-module commit we're using is public.
1282 # Without this, it is too easy to tag and release code that
1283 # cannot be built from a fresh clone.
1284 .PHONY: public-submodule-commit
1285 public-submodule-commit:
1286 $(AM_V_GEN)if test -d $(srcdir)/.git; then \
1287 cd $(srcdir) && \
1288 git submodule --quiet foreach test '$$(git rev-parse $$sha1)' \
1289 = '$$(git merge-base origin $$sha1)' \
1290 || { echo '$(ME): found non-public submodule commit' >&2; \
1291 exit 1; }; \
1292 else \
1293 : ; \
1294 fi
1295 # This rule has a high enough utility/cost ratio that it should be a
1296 # dependent of "check" by default. However, some of us do occasionally
1297 # commit a temporary change that deliberately points to a non-public
1298 # submodule commit, and want to be able to use rules like "make check".
1299 # In that case, run e.g., "make check gl_public_submodule_commit="
1300 # to disable this test.
1301 gl_public_submodule_commit ?= public-submodule-commit
1302 check: $(gl_public_submodule_commit)
1303
1304 .PHONY: alpha beta stable
1305 ALL_RECURSIVE_TARGETS += alpha beta stable
1306 alpha beta stable: $(local-check) writable-files $(submodule-checks)
1307 test $@ = stable \
1308 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1309 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1310 || :
1311 $(MAKE) vc-diff-check
1312 $(MAKE) news-check
1313 $(MAKE) distcheck
1314 $(MAKE) dist XZ_OPT=-9ev
1315 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1316 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1317
1318 # Override this in cfg.mk if you follow different procedures.
1319 release-prep-hook ?= release-prep
1320
1321 gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1322 .PHONY: release-prep
1323 release-prep:
1324 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1325 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
1326 $(MAKE) --no-print-directory -s announcement > ~/announce-$(my_distdir)
1327 if test -d $(release_archive_dir); then \
1328 ln $(rel-files) $(release_archive_dir); \
1329 chmod a-w $(rel-files); \
1330 fi
1331 echo $(VERSION) > $(prev_version_file)
1332 $(MAKE) update-NEWS-hash
1333 perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
1334 $(emit-commit-log) > .ci-msg
1335 $(VC) commit -F .ci-msg -a
1336 rm .ci-msg
1337
1338 # Override this with e.g., -s $(srcdir)/some_other_name.texi
1339 # if the default $(PACKAGE)-derived name doesn't apply.
1340 gendocs_options_ ?=
1341
1342 .PHONY: web-manual
1343 web-manual:
1344 @test -z "$(manual_title)" \
1345 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1346 @cd '$(srcdir)/doc'; \
1347 $(SHELL) ../$(_build-aux)/gendocs.sh $(gendocs_options_) \
1348 -o '$(abs_builddir)/doc/manual' \
1349 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1350 "$(PACKAGE_NAME) - $(manual_title)"
1351 @echo " *** Upload the doc/manual directory to web-cvs."
1352
1353 # Code Coverage
1354
1355 init-coverage:
1356 $(MAKE) $(AM_MAKEFLAGS) clean
1357 lcov --directory . --zerocounters
1358
1359 COVERAGE_CCOPTS ?= "-g --coverage"
1360 COVERAGE_OUT ?= doc/coverage
1361
1362 build-coverage:
1363 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1364 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1365 mkdir -p $(COVERAGE_OUT)
1366 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1367 --capture
1368
1369 gen-coverage:
1370 genhtml --output-directory $(COVERAGE_OUT) \
1371 $(COVERAGE_OUT)/$(PACKAGE).info \
1372 --highlight --frames --legend \
1373 --title "$(PACKAGE_NAME)"
1374
1375 coverage: init-coverage build-coverage gen-coverage
1376
1377 # Update gettext files.
1378 PACKAGE ?= $(shell basename $(PWD))
1379 PO_DOMAIN ?= $(PACKAGE)
1380 POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1381 PODIR ?= po
1382 refresh-po:
1383 rm -f $(PODIR)/*.po && \
1384 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1385 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1386 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1387 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1388 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1389
1390 # Running indent once is not idempotent, but running it twice is.
1391 INDENT_SOURCES ?= $(C_SOURCES)
1392 .PHONY: indent
1393 indent:
1394 indent $(INDENT_SOURCES)
1395 indent $(INDENT_SOURCES)
1396
1397 # If you want to set UPDATE_COPYRIGHT_* environment variables,
1398 # put the assignments in this variable.
1399 update-copyright-env ?=
1400
1401 # Run this rule once per year (usually early in January)
1402 # to update all FSF copyright year lists in your project.
1403 # If you have an additional project-specific rule,
1404 # add it in cfg.mk along with a line 'update-copyright: prereq'.
1405 # By default, exclude all variants of COPYING; you can also
1406 # add exemptions (such as ChangeLog..* for rotated change logs)
1407 # in the file .x-update-copyright.
1408 .PHONY: update-copyright
1409 update-copyright:
1410 grep -l -w Copyright \
1411 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1412 | $(update-copyright-env) xargs $(srcdir)/$(_build-aux)/$@
1413
1414 # This tight_scope test is skipped with a warning if $(_gl_TS_headers) is not
1415 # overridden and $(_gl_TS_dir)/Makefile.am does not mention noinst_HEADERS.
1416
1417 # NOTE: to override any _gl_TS_* default value, you must
1418 # define the variable(s) using "export" in cfg.mk.
1419 _gl_TS_dir ?= src
1420
1421 ALL_RECURSIVE_TARGETS += sc_tight_scope
1422 sc_tight_scope: tight-scope.mk
1423 @fail=0; \
1424 if ! grep '^ *export _gl_TS_headers *=' $(srcdir)/cfg.mk \
1425 > /dev/null \
1426 && ! grep -w noinst_HEADERS $(srcdir)/$(_gl_TS_dir)/Makefile.am \
1427 > /dev/null 2>&1; then \
1428 echo '$(ME): skipping $@'; \
1429 else \
1430 $(MAKE) -s -C $(_gl_TS_dir) \
1431 -f Makefile \
1432 -f $(abs_top_srcdir)/cfg.mk \
1433 -f $(abs_top_builddir)/$< \
1434 _gl_tight_scope \
1435 || fail=1; \
1436 fi; \
1437 rm -f $<; \
1438 exit $$fail
1439
1440 tight-scope.mk: $(ME)
1441 @rm -f $@ $@-t
1442 @perl -ne '/^# TS-start/.../^# TS-end/ and print' $(srcdir)/$(ME) > $@-t
1443 @chmod a=r $@-t && mv $@-t $@
1444
1445 ifeq (a,b)
1446 # TS-start
1447
1448 # Most functions should have static scope.
1449 # Any that don't must be marked with 'extern', but 'main'
1450 # and 'usage' are exceptions: they're always extern, but
1451 # do not need to be marked. Symbols matching '__.*' are
1452 # reserved by the compiler, so are automatically excluded below.
1453 _gl_TS_unmarked_extern_functions ?= main usage
1454 _gl_TS_function_match ?= /^(?:$(_gl_TS_extern)) +.*?(\S+) *\(/
1455
1456 # If your project uses a macro like "XTERN", then put
1457 # the following in cfg.mk to override this default:
1458 # export _gl_TS_extern = extern|XTERN
1459 _gl_TS_extern ?= extern
1460
1461 # The second nm|grep checks for file-scope variables with 'extern' scope.
1462 # Without gnulib's progname module, you might put program_name here.
1463 # Symbols matching '__.*' are reserved by the compiler,
1464 # so are automatically excluded below.
1465 _gl_TS_unmarked_extern_vars ?=
1466
1467 # NOTE: the _match variables are perl expressions -- not mere regular
1468 # expressions -- so that you can extend them to match other patterns
1469 # and easily extract matched variable names.
1470 # For example, if your project declares some global variables via
1471 # a macro like this: GLOBAL(type, var_name, initializer), then you
1472 # can override this definition to automatically extract those names:
1473 # export _gl_TS_var_match = \
1474 # /^(?:$(_gl_TS_extern)) .*?\**(\w+)(\[.*?\])?;/ || /\bGLOBAL\(.*?,\s*(.*?),/
1475 _gl_TS_var_match ?= /^(?:$(_gl_TS_extern)) .*?(\w+)(\[.*?\])?;/
1476
1477 # The names of object files in (or relative to) $(_gl_TS_dir).
1478 _gl_TS_obj_files ?= *.$(OBJEXT)
1479
1480 # Files in which to search for the one-line style extern declarations.
1481 # $(_gl_TS_dir)-relative.
1482 _gl_TS_headers ?= $(noinst_HEADERS)
1483
1484 .PHONY: _gl_tight_scope
1485 _gl_tight_scope: $(bin_PROGRAMS)
1486 t=exceptions-$$$$; \
1487 trap 's=$$?; rm -f $$t; exit $$s' 0; \
1488 for sig in 1 2 3 13 15; do \
1489 eval "trap 'v=`expr $$sig + 128`; (exit $$v); exit $$v' $$sig"; \
1490 done; \
1491 src=`for f in $(SOURCES); do \
1492 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1493 hdr=`for f in $(_gl_TS_headers); do \
1494 test -f $$f && d= || d=$(srcdir)/; echo $$d$$f; done`; \
1495 ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_functions); \
1496 grep -h -A1 '^extern .*[^;]$$' $$src \
1497 | grep -vE '^(extern |--)' | sed 's/ .*//'; \
1498 perl -lne \
1499 '$(_gl_TS_function_match) and print "^$$1\$$"' $$hdr; \
1500 ) | sort -u > $$t; \
1501 nm -e $(_gl_TS_obj_files) | sed -n 's/.* T //p'|grep -Ev -f $$t \
1502 && { echo the above functions should have static scope >&2; \
1503 exit 1; } || : ; \
1504 ( printf '^%s$$\n' '__.*' $(_gl_TS_unmarked_extern_vars); \
1505 perl -lne '$(_gl_TS_var_match) and print "^$$1\$$"' $$hdr *.h \
1506 ) | sort -u > $$t; \
1507 nm -e $(_gl_TS_obj_files) | sed -n 's/.* [BCDGRS] //p' \
1508 | sort -u | grep -Ev -f $$t \
1509 && { echo the above variables should have static scope >&2; \
1510 exit 1; } || :
1511 # TS-end
1512 endif